# Enum Class TileStatus

Object
Enum<TileStatus>
TileStatus

All Implemented Interfaces:
  `Serializable`, `Comparable<TileStatus>`, `Constable`

public enum TileStatus extends Enum<TileStatus>
Information about the availability of a tile. Some `TileMatrix` implementations may not know whether a tile exists or not before the first attempt to read that tile. Consequently, a tile status may be initially `UNKNOWN` and transitions at a later time to a state such as `EXISTS`, `MISSING` or `IN_ERROR`.

Since:
  1.2
See Also:
  - `Tile​.getStatus()`
  - `TileMatrix​.getTileStatus(long...)`

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class Enum

  `Enum​.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `EXISTS`
  The tile exists.
  `IN_ERROR`
  The tile exists but attempt to read it failed.
  `MISSING`
  The tile is flagged as missing.
  `OUTSIDE_EXTENT`
  The tile for which a status has been requested is outside the `TileMatrix` extent.
  `UNKNOWN`
  The tile status cannot be known unless the tile is read.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static TileStatus`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static TileStatus[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### UNKNOWN

    public static final TileStatus UNKNOWN
    The tile status cannot be known unless the tile is read. This value is returned by some `TileMatrix` implementations when determining the availability of a tile would require relatively costly I/O operations.

  - ### EXISTS

    public static final TileStatus EXISTS
    The tile exists. However, this is not a guarantee that no I/O error will happen when reading the tile, neither that the tile will be non-empty. If an I/O error happens at tile reading time, then the tile status should transition from `EXISTS` to `IN_ERROR`.

  - ### MISSING

    public static final TileStatus MISSING
    The tile is flagged as missing. It may happen in regions where no data is available.

  - ### OUTSIDE_EXTENT

    public static final TileStatus OUTSIDE_EXTENT
    The tile for which a status has been requested is outside the `TileMatrix` extent.

  - ### IN_ERROR

    public static final TileStatus IN_ERROR
    The tile exists but attempt to read it failed. It may be because an `IOException` occurred while reading the tile.

- ## Method Details

  - ### values

    public static TileStatus[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static TileStatus valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null